# all files / lighthouse-core/lib/ element.js

100% Statements 10/10
100% Branches 6/6
100% Functions 2/2
100% Lines 10/10

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52

    6×
    3×

    3×
    3×

    2×

    2×
    2×
    1×

    1×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    'use strict';

    class Element {

      constructor(element, driver) {
        if (!element || !driver) {
          throw Error('Driver and element required to create Element');
        }
        this.driver = driver;
        this.element = element;
      }

      /**
       * @param {!string} name Attribute name
       * @return {!Promise<?string>} The attribute value or null if not found
       */
      getAttribute(name) {
        return this.driver
          .sendCommand('DOM.getAttributes', {
            nodeId: this.element.nodeId
          })
          /**
           * @param {!{attributes: !Array<!string>}} resp The element attribute names & values are interleaved
           */
          .then(resp => {
            const attrIndex = resp.attributes.indexOf(name);
            if (attrIndex === -1) {
              return null;
            }
            return resp.attributes[attrIndex + 1];
          });
      }
    }

    module.exports = Element;